
//ExtUD.Ext.BidPlanFinanceInfo
Ext.define('hrmobile.public.myhome.related.forgetPasswordnextTwo', {
	extend : 'Ext.form.Panel',
	name : 'forgetPasswordnextTwo',
	constructor : function(config) {
		config = config || {};
		this.uuid = config.uuid;
		Ext.apply(config, {
			width : "100%",
			height : "100%",
			fullscreen : true,
			scrollable : {
				direction : 'vertical'
			},
			items : [ {
				xtype : 'panel',
				style : 'margin:15px;border: 1px solid #eee;border-radius: 5px;',
				defaults : {
					xtype : 'passwordfield',
					labelAlign : "top"
				},
				items : [ {
					label : "<div style='font-size:14px'>新登录密码</div>",
					placeHolder : "请输入新的登录密码",
					style : 'margin:10px;font-size:1em;color:#fff;border-bottom: 1px solid #dddddd;',
					name : 'password'
				}
					,
					{
						xtype : "hiddenfield",
						name : "random",
						value : this.uuid
					},
					{
						label : "<div style='font-size:14px'>确认新登录密码</div>",
						placeHolder : "请确认新登录密码",
						style : 'margin:10px;font-size:1em;color:#fff;border-bottom: 1px solid #dddddd;',
						name : 'repeat_password'
					},
					{
						xtype : "label",
						name : "note",
						id : "note",
						html : "  "
					},
					{
						style : "margin:20px 20px 200px 20px;background:" + themeColor + ";font-color:white",
						xtype : 'button',
						text : "<font color=white>提交</font>",
						handler : this.submit1
					} ]
			} ]
		});




		this.callParent([ config ]);

	},
	submit1 : function() {
		var loginForm = this.up('formpanel');
		if (loginForm.validate(loginForm.items)) {
			var password = loginForm.getCmpByName('password').getValue();
			var repeat_password = loginForm.getCmpByName('repeat_password').getValue();
			var random = loginForm.getCmpByName('random').getValue();
			var note = Ext.getCmp('note');

			if (Ext.isEmpty(password)) {
				note.setHtml("<div style='margin:10px;'><font color='" + themeColor + "'>新登录密码不能为空</font></div>");
				return;
			}


			if (Ext.isEmpty(repeat_password)) {
				note.setHtml("<div style='margin:10px;'><font color='" + themeColor + "'>确认新登录密码不能为空</font></div>");
				return;
			}
			if (password.length < 6 || password.length > 16) {
				note.setHtml('<div class="prompt" style="display: block;"><i class="icon-exclamation-sign icon-large"></i> <p class="prompt-font">密码长度为6~16个字符</p></div>');
				return;
			}
			var reg = new RegExp(/^([a-zA-Z]+)$/);
			if (!isNaN(password) || reg.test(password)) {
				note.setHtml('<div class="prompt" style="display: block;"><i class="icon-exclamation-sign icon-large"></i> <p class="prompt-font">密码只能字母和数字组成</p></div>');
				return;
			}
			if (!password.match(/^[a-zA-Z0-9]+$/)) {
				note.setHtml('<div class="prompt" style="display: block;"><i class="icon-exclamation-sign icon-large"></i> <p class="prompt-font">密码只能由字母和数字组成</p></div>');
				return;
			}
			if (repeat_password != password) {
				note.setHtml('<div class="prompt" style="display: block;"><i class="icon-exclamation-sign icon-large"></i> <p class="prompt-font">两次输入的密码不一致</p></div>');
				return;
			}
			password=b64_sha256(password);
			Ext.Ajax.request({
				url : __ctxPath + '/user/resetPasswordBpCustMember.do',
				params : {
					isMobile : "1",
					password:password,
					random:random
				},
				method : 'POST',
				success : function(response) {
					var responseText1 = response.responseText.replace(/[\n]/ig, '');
					var obj = Ext.util.JSON.decode(responseText1);
					if (obj.result == 1) {
						//登录信息
						curUserInfo = obj.data;
						if (!Ext.isEmpty(Ext.get("login"))) {
							Ext.get("login").destroy();
						}
						if (!Ext.isEmpty(Ext.get("register"))) {
							Ext.get("register").destroy();
						}
						if (!Ext.isEmpty(Ext.get("logout"))) {
							Ext.get("logout").show();
						}
						mobileNavi.destroy();
						mobileNavi = Ext.create('mobile.View', {});
						mobileView.add(mobileNavi);
						Ext.Msg.alert('', '修改成功，请牢记您的密码');
					} else {
						Ext.Msg.alert('', obj.errMsg);
					}
				},
				failure : function(form, action, response) {
					var obj = Ext.util.JSON.decode(response);
					Ext.Msg.alert('', obj.errMsg);
				}
			});
		}

	}
});