var express = require('express');
var app = require('express')();
var config = require('./config');// 载入配置文件
var http = require('http').Server(app);
var https = require('http');
var io = require('socket.io')(http);
var url = require("url");            //解析GET请求
var query = require("querystring");    //解析POST请求
var logger=require('./logger');


//路径
var fs = require('fs');
var path = require('path');
//时间格式化
var moment = require('moment');
//生成随机数
var crypto = require('crypto');



//数据库操作
var db_insert = require('./sql/mysql-insert');//  数据库插入数据
var db_select = require('./sql/mysql-select');// 查询
var db_updateState = require('./sql/mysql-updateState');//更改员工的登陆状态
var db_update = require('./sql/mysql-select');// 查询
var db_delete = require('./sql/mysql-delete');// 删除
// 房间用户名单
var roomInfo = {};
var users = [];

//用来存放用户和该用户的的登陆socket,用于创建一对一聊天
var users2 = {};

/*//用户登录时初始化群列表
var show_rooms = {};*/
//用户登录时初始化群里面的用户列表
var show_room_users = {};
//用户登录时初始化所有在线用户
/*var show_online_users = {};*/
//常用语集合
//var show_common_word = {};
//常用文件集合
//var show_common_file = {};


//用ip和端口访问就指定服务的根目录
app.use(express.static(__dirname + '/'));

app.get('/', function (req, res) {
    res.send('<h1>服务已启动！</h1>');
});
app.get('/ChatRoom/login*', function(request, response){
    //通过get方式请求的页面如果checkCode有值且能在数据库匹配上则登陆成功
})
//登陆服务
app.post('/ChatRoom/login*', function(request, response){
    //定义报文头
    response.writeHead(200,{"Content-Type":"text/json","Access-Control-Allow-Origin":"*"});
    var postdata = "";
    request.addListener("data",function(postchunk){
        postdata += postchunk;
    })

    //POST结束输出结果
    request.addListener("end",function(){
        var params = query.parse(postdata);
        //params['fruit'] = compute(params);
        var strs=JSON.stringify(params);
        //返回登陆成功页面,user表中有数据
        //没有账号就创建
       var sql = "select * from chat_user where systemUserId=" + params.userId + ";";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.info(err);
                response.write("{'err':'err'}");
                response.end();
            } else {
                if (vals.length == 0) {
                    //没有该用户---创建
                    //返回让其直接登陆
                    response.write(strs);
                    response.end();
                    return;
                }else{
                    //这里判断下该用户是否在线，如果已经在线就不打开了
                    var code=getRandomStr(16);
                    //存入数据库
                    var updateSql = "update chat_user set loginCheckCode='" + code + "'  where systemUserId=" + params.userId + ";";
                    logger.info("添加校验码sql："+updateSql);
                    db_update(updateSql, function (err, vals, fields) {
                        if (err) {
                            throw err;
                        } else {
                            logger.info("添加校验码到数据库成功！");
                            //返回
                            var rsText='{"loginCode":"'+code+'"}';
                            response.write(rsText);
                            response.end();
                        }
                    });
                }

            }
        });

        //window.open(config.loginURL);
        //针对这个用户让其自动登陆
        //var aaa = JSON.parse(strs);
       // logger.info(aaa.userId);
        logger.info(params.userId);

    })

});



//方法部分
io.sockets.on('connection', function (socket) {
    //新用户登录
    socket.on('login', function (nickname) {
        //logger.info("users.indexOf(nickname):"+users.indexOf(nickname));
        //logger.info("users2[nickname]:"+users2[nickname]);
        if (users.indexOf(nickname) > -1 || users2[nickname]) {
            //此时说明已经登陆了一个
            //不让登陆
            socket.emit('nickExisted');
        } else {
            //用户的背景样式
            var userStyle = "";
            socket.userIndex = users.length;
            socket.nickname = nickname;
            //根据名称查询数据库
            //估计到时需要判断用户名和密码
            var sql = "select * from chat_user where chatUserName='" + nickname + "';";
            db_select(sql, function (err, vals, fields) {
                if (err) {
                    logger.info(err);
                } else {
                    if (vals.length == 0) {
                        //没有该用户
                        return;
                    } else {
                        //查询到了，获取userid
                        socket.userid = vals[0].id;
                        socket.showName=vals[0].showName;
                        //获取该用户的背景设置
                        userStyle = vals[0].style;
                        //users数组中也可以取到当前登录的所有用户（现在是从数据库中获取的）
                        users.push(nickname);
                        socket.emit('loginSuccess', userStyle,socket.showName);


                        //调用数据库更改状态   员工状态  0：离线   1：在线空闲  2：在线忙碌
                        db_updateState(1, nickname, function (err, vals, fields) {
                            if (err) {
                                logger.info(err);
                            } else {
                                logger.info(nickname + '登陆成功，员工状态更新为在线空闲');
                                //用户登录成功将该用户的name和socket存入users2
                                if (nickname in users2) {
                                    //如果已经存在，就删除原来的，然后加上现在的
                                    delete users2[nickname];
                                    users2[nickname] = socket;
                                } else {
                                    users2[nickname] = socket;
                                }
                                //向所有人广播登陆消息
                                //io.sockets.emit('system', nickname, users.length, 'login');
                            }
                        });
                        //更新所有登陆用户的在线用户列表
                        io.sockets.emit('userStateChange',socket.nickname,socket.showName, "login");
                    }
                }
            });
        }
        ;
    });
    //用户登陆时加载他公司的所有在线员工
    //员工状态  0：离线   1：在线空闲  2：在线忙碌
    socket.on('initOnlineUsers', function (loginName) {
        var sql = "select * from chat_user where state in (1,2);";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    return;
                } else {
                    //循环该列表，获取所有在线用户
                    for (var i = 0; i < vals.length; i++) {
                        var id = vals[i].id;
                        var name = vals[i].chatUserName;
                        //从列表中去除自己
                        /*if(name==loginName){
                         logger.info("去除自身，name:"+loginName);
                         continue;
                         }*/
                        /*
                         var state=vals[i].state;*/
                        var show_online_users = {}
                        show_online_users[id] = vals[i];
                    }
                    //回调该用户客户端
                    socket.emit('show onlineUsers', show_online_users);
                }
            }
        });
    });
    //用户登陆时加载他所有的群列表
    socket.on('initRooms', function (loginName) {
        //查询该用户的群列表
        //先根据传过来的用户名获取到用户id
        //然后根据用户id在群和用户关联表中查询所有的群id
        var sql = "select * from chat_user where chatUserName='" + loginName + "';";
        console.log("sql1111111：" +sql);
        //`chat_room_member`
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                //logger.info('查询成功');
                if (vals.length == 0) {
                    return;
                }
                var userid = vals[0].id;//获取群的id字符串
                if (userid) {
                    var roomsSql = "select * from chat_room where id  in (select roomId from chat_room_member where userId= " + userid + ") and state=0;";
                    console.log("roomsSql22222：" +roomsSql);
                    db_select(roomsSql, function (err, vals, fields) {
                        if (err) {
                            logger.error(err);
                        } else {
                            //获取到是群列表
                            if (vals) {
                                //循环该列表，获取该群里的所有用户
                                var show_rooms = {}
                                for (var i = 0; i < vals.length; i++) {
                                    var roomid = vals[i].id;
                                    var roomname = vals[i].roomName;
                                    console.log("群id：" + roomid + ",群名称为：" + roomname);
                                    show_rooms[roomid] = vals[i];
                                    //该用户需要把socket加入该房间
                                    //同一个账号，下线上线会再一次的加入该房间啊
                                    //这里还需要去重啊。。。。。。。。。。。。。。。
                                    //现在是只进不出啊。。。。。。。。。。。。。。。
                                    socket.join(roomid);    // 加入房间
                                    var roomid_sockets = io.sockets.adapter.rooms;
                                    //logger.info("该房间的socketid数组为："+roomid_sockets[roomid]);
                                }
                                //show_room_users[roomid]
                                //回调该用户客户端
                                socket.emit('show rooms', show_rooms, show_room_users);
                            }else{
                                socket.emit('show rooms', show_rooms, show_room_users);
                            }
                        }
                    });
                }
            }

        });
    });

    //用户退出
    socket.on('disconnect', function () {
        users.splice(socket.userIndex, 1);
        //users2也需要去除存入的name-socket
        delete users2[socket.nickname];

        //调用数据库更改状态   员工状态  0：离线   1：在线空闲  2：在线忙碌
        db_updateState(0, socket.nickname, function (err, vals, fields) {
            if (err) {
                logger.info(err);
            } else {
                logger.info(socket.nickname + '退出成功，员工状态更新为离线空闲');
            }
        });
        //io.sockets.emit('system', socket.nickname, users.length, 'logout');
        io.sockets.emit('userStateChange', socket.nickname,socket.showName, "logout");
    });
    //向个人发送信息
    socket.on('post personMsg', function (msg, color, personnickname, personShowname) {
        //io.sockets.emit('newMsg', socket.nickname, msg, color);
        logger.info('进入消息方法服务：' + msg);
        //给所有的链接服务的用户发送消息
        //logger.info('房间1：'+roomInfo[1]);
        //判断自己是否在线，没有的话就需要重新登陆
        if (!(socket.nickname in users2)) {
            //users数组中把用户去掉
            users.splice(socket.userIndex, 1);

            socket.emit('self not online', personnickname);
            return;//自己不在线
        }

        if (personnickname in users2) {
            //users[to].emit('newMsg', socket.nickname, msg, color);
            //(有时不知什么原因会出现收不到的情况)
            //有时会出现自己给自己发送
            if (personnickname == socket.nickname) {
                //此时只显示一条
                users2[personnickname].emit('newMsg', socket.showName, msg, color, "title_user" + socket.nickname, socket.showName);
            } else {
                users2[personnickname].emit('newMsg', socket.showName, msg, color, "title_user" + socket.nickname, socket.showName);
                //自己也需要显示
                socket.emit('newMsg', socket.showName, msg, color, "title_user" + personnickname, socket.showName);
            }

            //用以保存至数据库的聊天内容（不要聊天的表情，图片，文件）
            //此处的roomid需要定义个规则

            var roomid = socket.nickname + "_" + personnickname;
            if ((socket.nickname + "") > (personnickname + "")) {
                roomid = personnickname + "_" + socket.nickname;
            }

            //var t = new Date().toLocaleTimeString();//当前时间
            var t=getNowFormatDate();
            //格式化特殊字符
            msg=formatSpecialWord(msg);
            //logger.info('格式化后的字符为' + msg);
            var befContent='<li><div class="you-speak ' + color + '"><span>' + socket.showName + '</span><i>' + t + '</i></div><div class="we-chat-con"><font color=\"' + color + '\">';
            var aftContent =  '</font></div></li>';
            saveContent(roomid, befContent,msg,aftContent);
            saveContentDetail(roomid,socket.userid,socket.nickname,msg);
        } else {
            //对方不在线
            socket.emit('other not online', personnickname);
        }
        //这个不知道给谁发
        //socket.to(1).emit('newMsg', socket.nickname, msg, color);

    });
    //群信息
    socket.on('post roomMsg', function (msg, color, roomid, roomname) {
        //throw new Error('Catch me');
        //判断自己是否在线，没有的话就需要重新登陆
        if (!(socket.nickname in users2)) {
            //users数组中把用户去掉
            users.splice(socket.userIndex, 1);
            socket.emit('self not online', socket.nickname);
            return;//自己不在线
        }
        //判断自己是否还在这个聊天室如果不再,就不让发送消息
        var sql = "select * from chat_room_member where roomId="+roomid+" and userId="+socket.userid+";";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    //该用户已经不再该群里了
                    socket.emit('show message', "你已经退出了该群，请重新登陆查看！");
                    return;
                } else {
                    // 通知房间内人员
                    io.sockets.in(roomid).emit('newMsg', socket.showName, msg, color, "title_room" + roomid, roomname);

                    //用以保存至数据库的聊天内容（不要聊天的表情，图片，文件）
                    //格式化特殊字符
                    msg=formatSpecialWord(msg);
                    //logger.info('格式化后的字符为' + msg);

                    //var t = new Date().toLocaleTimeString();//当前时间
                    var t=getNowFormatDate();
                    var befContent='<li><div class="you-speak ' + color + '"><span>' + socket.showName + '</span><i>' + t + '</i></div><div class="we-chat-con"><font color=\"' + color + '\">';
                    var aftContent =  '</font></div></li>';
                    saveContent(roomid, befContent,msg,aftContent);
                    saveContentDetail(roomid,socket.userid,socket.showName,msg);
                }
            }
        });
    });


    //向个人发送文件
    //type 为文件格式 0：图片  1：非图片
    //talktype  聊天的类型  pri:个人对个人  pub：聊天室
    //perOrRoomName  聊天对象的名字（个人名或聊天室名）
    socket.on('post file', function (file_data, othername, filetype, filename, talktype, perOrRoomName, fileSize) {
        logger.info('进入发送文件服务');
        //格式化文件大小
        fileSize = renderSize(fileSize);
        //图标名称
        var fileIconName = "image";
        //文件名
        var fileShowName = filename;
        //需要往前台传送文件类型
        if (filetype == 1) {//非图片
            fileIconName = getFileIconName(filename);//获取文件的类型，并把文件图标赋值
        }

        //判断自己是否在线，没有的话就需要重新登陆
        if (!(socket.nickname in users2)) {
            //users数组中把用户去掉
            users.splice(socket.userIndex, 1);

            socket.emit('self not online', personname);
            return;//自己不在线
        }
        //先保存文件,文件存放规则    路径为：项目根目录/file/日期/聊天室ID/      (暂时不加聊天室ID)
        //针对于个人对个人的聊天  聊天室ID为：personid1_personid2    较小的personid在前面
        //每天创建一个当天日期的文件夹，该文件夹中按聊天室创建属于该聊天室的文件夹
        //当天该聊天室所有的文件都存放在该文件夹下
        var nowDate = moment().format('YYYYMMDD');
        //logger.info('当前日期：' + nowDate);
        var dirPath = __dirname + '/file/' + nowDate;
        todayFileDirIsExist(dirPath);//调用判断文件夹是否存在方法

        var filePath = dirPath + "/" + filename;
        //这里是需要存入数据库的路径，为相对路径
        var sqlPath = '/file/' + nowDate + "/";
        fs.exists(filePath, function (exists) {
            if (exists) {//存在
                //生成4位随机数
                var token = Math.floor(Math.random() * 10000);
                //文件名有1.txt  1.2.txt,1 1.2 将文件名进行切割
                var res = filename.indexOf("\.");
                if (res > 0) {//文件包含点，此处认为是有文件类型的，进行文件名的重组
                    var n = filename.lastIndexOf("\.");
                    var befStr = filename.substring(0, n);
                    filename = filename.replace(befStr, befStr + "_" + token);
                    filePath = dirPath + "/" + filename;
                } else {
                    filename = filename + "_" + token;
                    filePath = dirPath + "/" + filename;
                }
            }
            //加上文件名
            sqlPath = sqlPath + filename;

            //writeFile好像不好用，此处用write方法
            logger.info("写文件时的路径为：" + filePath);
            fs.open(filePath, 'a', function (err, fd) {
                if (err) {
                    throw err;
                }
                // fs.write(fd, data, 0 , 'utf-8', function(err, written, string){
                //向文件写入数据
                fs.write(fd, file_data, null, 'Binary',
                    function (err, written) {
                        if (err) {
                            throw err;
                        }
                        fs.close(fd, function (err) {
                            if (err) {
                                throw err;
                            }
                            logger.info('文件流关闭！');
                        })
                    });
            });
            //文件上传成功后，信息存入数据库
            //调用数据库更改状态   员工状态  0：离线   1：在线空闲  2：在线忙碌
            var roomid = socket.nickname + "_" + othername;//默认个人对个人
            /*if ((socket.nickname + "") > (othername + "")) {
                roomid = othername + "_" + socket.nickname;
            }*/

            if (talktype == "pub") {//聊天室
                roomid = othername;
            }

            var insertSql = "insert into chat_file (`roomId` ,`createtime`,`path`,`fileType`,`fileName`,`fileSize`,`uploadUserName`) VALUES" +
                " ('" + roomid + "', now(),'" + sqlPath + "'," + filetype + ",'" + filename + "','" + fileSize + "','"+socket.nickname+"')";//此处的路径包含文件名   fileType 0:图片  1：非图片

            logger.info("插入文件信息sql：" + insertSql);
            db_insert(insertSql, function (err, vals, fields) {
                if (err) {
                    throw err;
                } else {
                    logger.info("文件信息保存到数据库成功！");
                }
            });


            //广播显示图片或文件时，返回的路径为：项目服务地址+sqlPath
            var showPath = config.serverURL + sqlPath;
            //logger.info("服务器的文件访问地址为："+showPath);

            //图片需要存入聊天记录（不是图片就不需要）
            if (filetype == 0) {//图片
                //var t = new Date().toLocaleTimeString();//当前时间
                var t=getNowFormatDate();
                var content = '<div class="you-speak"><span>' + socket.showName + '</span><i>' + t + '</i></div><div class="we-chat-con"><a href="' + showPath + '" target = "_blank"><img width="200px" height="160px" src="' + showPath + '"/></a></div>';
                saveContent(roomid,"",content,"");
                saveContentDetail(roomid,socket.userid,socket.showName,content);
            }



            if (talktype == "pri") {//个人对个人
                //聊天对象在线
                if (othername in users2) {
                    //自己给自己发文件
                    if (othername == socket.nickname) {
                        //此时只显示一条
                        //自己显示该图片或文件
                        socket.emit('newFile', showPath, socket.showName, "title_user" + othername, perOrRoomName, fileIconName, fileShowName, fileSize);
                    } else {
                        //自己显示该图片或文件
                        socket.emit('newFile', showPath, socket.showName, "title_user" + othername, perOrRoomName, fileIconName, fileShowName, fileSize);
                        //对方显示
                        users2[othername].emit('newFile', showPath, socket.showName, "title_user" + socket.nickname, socket.nickname, fileIconName, fileShowName, fileSize);
                    }
                } else {
                    //可能需要加上离线消息。。。。。。。。。。。
                    //对方不在线，提示自己
                    socket.emit('other not online', othername);
                }
            } else if (talktype == "pub") {//聊天室
                io.sockets.in(othername).emit('newFile', showPath, socket.nickname, "title_room" + othername, perOrRoomName, fileIconName, fileShowName, fileSize);
            }

        });
    });

    //初始化常用语和常用文件
    //有针对全局的，和针对个人的
    socket.on('initChangyongWordAndFile', function () {
        //从数据库中读出常用语和常用文件
        var show_common_word = {};
        //常用文件集合
        var show_common_file = {};

        //需要先查询系统的用户id
        var sql = "select * from chat_user where id = "+socket.userid+";";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    return;
                } else {
                    var systemUserId=vals[0].systemUserId;
                    //查询全局的和私有的
                    var sql = "select * from chat_term where termType=0 or (termType=1 and addPersonId = "+systemUserId+");";
                    db_select(sql, function (err, vals, fields) {
                        if (err) {
                            logger.error(err);
                        } else {
                            //查询到了，获取userid
                            //循环该列表，获取所有在线用户
                            for (var i = 0; i < vals.length; i++) {
                                var id = vals[i].id;
                                var editType = vals[i].editType;//类型 0 常用语 1 文件
                                if (editType == 0) {
                                    show_common_word[id] = vals[i];
                                } else if (editType == 1) {
                                    show_common_file[id] = vals[i];
                                }
                            }

                            //项目服务地址+数据库的Path===文件的下载路径
                            var showPath = config.serverURL;
                            //把获取到的常用语和文件，返回给页面
                            socket.emit('show commonWordAndFile', show_common_word, show_common_file,showPath);
                        }
                    });
                }
            }})
    });


    /*socket.on('disconnect', function () {
     // 从房间名单中移除
     var index = roomInfo[roomID].indexOf(user);
     if (index !== -1) {
     roomInfo[roomID].splice(index, 1);
     }

     socket.leave(roomID);    // 退出房间
     socketIO.to(roomID).emit('sys', user + '退出了房间', roomInfo[roomID]);
     logger.info(user + '退出了' + roomID);
     });*/

    //监控用户改变登陆状态（现在只支持上线和下线）
    socket.on('change state', function (state) {
        var nickname=socket.nickname;
        // 获取该用户名socket.nickname
        //先获取该用户的当前状态，与变更状态进行比较，一样就不做处理
        var sql = "select * from chat_user where chatUserName='" + socket.nickname + "';";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    //没有该用户
                    return;
                } else {
                    //查询到了，获取userid
                    var nowstate = vals[0].state;
                    if (state == nowstate) {
                        return;
                    } else {
                        //更改状态
                        var updateSql = "update chat_user set state=" + state + " where chatUserName='" + socket.nickname + "'";
                        db_update(updateSql, function (err, vals, fields) {
                            if (err) {
                                throw err;
                            } else {
                                if(state==="1"){
                                    //所有在线用户需要更新好友列表
                                    //现在有三种状态，上线，隐身，离线
                                    //相当于重新登陆
                                    //调用数据库更改状态   员工状态  0：离线   1：在线空闲  2：在线忙碌
                                    db_updateState(1, nickname, function (err, vals, fields) {
                                        if (err) {
                                            logger.info(err);
                                        } else {
                                            logger.info(nickname + '登陆成功，员工状态更新为在线空闲');
                                            //用户登录成功将该用户的name和socket存入users2
                                            if (nickname in users2) {
                                                //如果已经存在，就删除原来的，然后加上现在的
                                                delete users2[nickname];
                                                users2[nickname] = socket;
                                            } else {
                                                users2[nickname] = socket;
                                            }
                                            //向所有人广播登陆消息
                                            //io.sockets.emit('system', nickname, users.length, 'login');
                                            //更新所有登陆用户的在线用户列表
                                            io.sockets.emit('userStateChange', nickname,socket.showName, "login");
                                        }
                                    });
                                }else if(state==="0"){
                                    //离线，相对于退出吧
                                    users.splice(socket.userIndex, 1);
                                    //users2也需要去除存入的name-socket
                                    delete users2[socket.nickname];

                                    //调用数据库更改状态   员工状态  0：离线   1：在线空闲  2：在线忙碌
                                    db_updateState(0, socket.nickname, function (err, vals, fields) {
                                        if (err) {
                                            logger.info(err);
                                        } else {
                                            logger.info(socket.nickname + '退出成功，员工状态更新为离线空闲');
                                        }
                                    });
                                    //io.sockets.emit('system', socket.nickname, users.length, 'logout');
                                    io.sockets.emit('userStateChange', socket.nickname,socket.showName, "logout");
                                }else if(state==="2"){
                                    //隐身状态
                                    //可以发送和接收消息，别人看不见在线
                                    io.sockets.emit('userStateChange', socket.nickname,socket.showName, "logout");
                                }

                            }
                        });
                    }
                }
            }
        });


    });


    //监控用户背景图案的改变
    socket.on('change bgstyle', function (style) {
        // 获取该用户名socket.nickname
        //更改状态
        var updateSql = "update chat_user set style='" + style + "' where chatUserName='" + socket.nickname + "'";
        db_update(updateSql, function (err, vals, fields) {
            if (err) {
                throw err;
            } else {
                logger.info("保存用户背景成功！");
            }
        });
    });


    //查询聊天群或聊天好友
    socket.on('search roomOrPer', function (word) {
        var search_roomOrPers = {};
        //根据关键词查询聊天室或好友

        //这里只查询聊天室
        var sql = "select * from chat_room where roomName like '%" + word + "%'  order by id desc;";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                //还需查询相关的聊天室，把查询到的聊天对象和聊天室都存入集合返回
                //页面显示
                //第二个参数为聊天室的成员
                socket.emit('show searchRooms', vals,"");
            }
        });
    });
    //查询常用语
    socket.on('search commonWord', function (word) {
        var search_commonWords = {};
        var search_commonFiles = {};
        //根据关键词查询聊天室或好友
        //还需判断该文件是全局还是个人，
        //文件的话，怎么获取文件信息
        var sql = "select * from chat_term where editType=1 or (content like '%" + word + "%' and editType=0) order by id desc;";
        logger.info("查询常用语sql:"+sql);
        if(word.trim()==""){
            logger.info("word为空串！");
            sql = "select * from chat_term order by id desc;";
        }
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                //循环该列表，获取所有在线用户
                for (var i = 0; i < vals.length; i++) {
                    var id = vals[i].id;
                    var editType = vals[i].editType;//类型 0 常用语 1 文件
                    if (editType == 0) {
                        search_commonWords[id] = vals[i];
                    } else if (editType == 1) {
                        search_commonFiles[id] = vals[i];
                    }
                }
                //把获取到的常用语和文件，返回给页面
                socket.emit('show commonWordAndFile', search_commonWords, search_commonFiles);
            }
        });
    });


    //查询常用文件
    socket.on('search commonFile', function (word) {
        var search_commonWords = {};
        var search_commonFiles = {};
        //根据关键词查询常用文件
        var sql = "select * from chat_term where editType=0 or (fileName like '%" + word + "%' and editType=1) order by id desc;";
        //logger.info("查询常用文件sql:"+sql);
        if(word.trim()==""){
            logger.info("word为空串！");
            sql = "select * from chat_term order by id desc;";
        }
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.info(err);
            } else {
                //循环该列表，获取所有在线用户
                for (var i = 0; i < vals.length; i++) {
                    var id = vals[i].id;
                    var editType = vals[i].editType;//类型 0 常用语 1 文件
                    if (editType == 0) {
                        search_commonWords[id] = vals[i];
                    } else if (editType == 1) {
                        search_commonFiles[id] = vals[i];
                    }
                }
                //把获取到的常用语和文件，返回给页面
                socket.emit('show commonWordAndFile', search_commonWords, search_commonFiles);
            }
        });
    });

    //查询常用文件
    socket.on('search historyFileSerch', function (word,talkid, type) {
        var roomid = talkid;
        if (type == "person") {
            roomid = socket.nickname + "_" + talkid;
            if ((socket.nickname + "") > (talkid + "")) {
                roomid = talkid + "_" + socket.nickname;
            }
        }

        var filesql = "select * from chat_file where roomId in('" + socket.nickname + "_" + talkid + "','"+ talkid+ "_" + socket.nickname+"') and fileType = 1 and fileName like '%" + word + "%' order by id desc;";
        if (type == "room") {
            filesql = "select * from chat_file where roomId ='"+talkid+"' and fileType = 1  and fileName like '%" + word + "%' order by id desc;";
        }
        logger.info("filesql:" + filesql);
        db_select(filesql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    //没有文件
                    socket.emit('show historyFile', "",showPath);
                } else {
                    //查询到了，获取userid
                    //logger.info("查询聊天文件" + vals[0].fileName);
                    //广播显示图片或文件时，返回的路径为：项目服务地址+sqlPath
                    var showPath = config.serverURL;
                    socket.emit('show historyFile', vals,showPath);
                }
            }
        });

    });

    //消息记录(包括文件)的显示
    socket.on('get historyMsgAndFile', function (talkid, type) {
        var roomid = talkid;
        if (type == "person") {
            roomid = socket.nickname + "_" + talkid;
            if ((socket.nickname + "") > (talkid + "")) {
                roomid = talkid + "_" + socket.nickname;
            }
        }
        logger.info("查询聊天记录的房间ID为："+roomid);
        //根据这个roomid获取聊天记录
        var sql = "select * from chat_log where roomId='" + roomid + "' order by id desc;";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    //没有消息
                    socket.emit('show historyMsg', "");
                } else {
                    //查询到了，获取userid
                    //logger.info("查询聊天记录" + vals[0].chatLog);
                    //如果返回所有的聊天记录，数据量太大
                    //测试只返回最近的一天的数据
                    //在这里进行日期的转换吧
                    socket.emit('show historyMsg', vals[0]);
                }
            }
        });

        //
        var filesql = "select * from chat_file where roomId in('" + socket.nickname + "_" + talkid + "','"+ talkid+ "_" + socket.nickname+"') and fileType = 1 order by id desc;";
        if (type == "room") {
            filesql = "select * from chat_file where roomId ='"+talkid+"' and fileType = 1 order by id desc;";
        }
        logger.info("filesql:" + filesql);
        db_select(filesql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    //没有文件
                    socket.emit('show historyFile', "",showPath);
                } else {
                    //查询到了，获取userid
                    //logger.info("查询聊天文件" + vals[0].fileName);
                    //广播显示图片或文件时，返回的路径为：项目服务地址+sqlPath
                    var showPath = config.serverURL;
                    socket.emit('show historyFile', vals,showPath);
                }
            }
        });

    });


    //查询指定日期前一天的消息记录(不包括文件)的显示
    socket.on('search historyMsg', function (talkid, date,type,findType) {
        //findType  查询方式
        //date  按日期  prev  前一天   content 按内容  after  向后一天  还有最前一天  最后一天

        var roomid = talkid;
        if (type == "person") {
            roomid = socket.nickname + "_" + talkid;
            if ((socket.nickname + "") > (talkid + "")) {
                roomid = talkid + "_" + socket.nickname;
            }
        }
        logger.info("查询聊天记录的房间ID为："+roomid);
        //根据这个roomid获取聊天记录
        //select * from chat_log where roomId='1'and DATE_FORMAT(chatTime,'%Y-%m-%d')='2016-09-26' order by id desc;
        var sql="";
        if(findType=="prev"){
            sql = "select * from chat_log where roomId='" + roomid + "'and DATE_FORMAT(chatTime,'%Y-%m-%d')<'"+date+"' order by id desc;";
        }else if(findType=="date"){
            sql = "select * from chat_log where roomId='" + roomid + "'and DATE_FORMAT(chatTime,'%Y-%m-%d')='"+date+"' order by id desc;";
        }else if(findType=="after"){
            sql = "select * from chat_log where roomId='" + roomid + "'and DATE_FORMAT(chatTime,'%Y-%m-%d')>'"+date+"' order by id asc;";
        }else if(findType=="first"){
            sql = "select * from chat_log where roomId='" + roomid + "' order by id asc;";
        }else if(findType=="last"){
            sql = "select * from chat_log where roomId='" + roomid + "' order by id desc;";
        }
        logger.info("查询聊天记录sql："+sql);
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    //没有消息
                    socket.emit('show historyMsg', "");
                } else {
                    //查询到了，获取userid
                    //logger.info("查询聊天记录" + vals[0].chatLog);
                    //如果返回所有的聊天记录，数据量太大
                    //测试只返回最近的一天的数据
                    //在这里进行日期的转换吧vals.length
                    var len=vals.length;
                    socket.emit('show historyMsg', vals[0],findType,len);
                }
            }
        });
    });


    //按关键词查找相对应的内容
    socket.on('searchByContent', function (talkid,type,searchRange,searchContent) {
        var roomid = talkid;
        if (type == "person") {
            roomid = socket.nickname + "_" + talkid;
            if ((socket.nickname + "") > (talkid + "")) {
                roomid = talkid + "_" + socket.nickname;
            }
        }
        logger.info("查询聊天记录的房间ID为："+roomid);
        //根据这个roomid获取聊天记录
        var sql="";
        if(searchRange=="三天内"){
            sql = "select * from chat_log_detail where roomId='" + roomid + "'and  DATEDIFF(NOW(),chatTime)<3 and content like '%"+searchContent+"%' order by id desc;";
        }else if(searchRange=="一周内"){
            sql = "select * from chat_log_detail where roomId='" + roomid + "'and  DATEDIFF(NOW(),chatTime)<7 and content like '%"+searchContent+"%' order by id desc;";
        }else if(searchRange=="一个月内"){
            sql = "select * from chat_log_detail where roomId='" + roomid + "'and  DATEDIFF(NOW(),chatTime)<30 and content like '%"+searchContent+"%' order by id desc;";
        }else if(searchRange=="全部"){
            sql = "select * from chat_log_detail where roomId='" + roomid + "' and content like '%"+searchContent+"%' order by id desc;";
        }
        logger.info("查询聊天记录sql："+sql);
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    //没有消息
                    socket.emit('show historyMsg', "");
                } else {
                    //查询到了，获取userid
                    //logger.info("查询聊天记录" + vals[0].chatLog);
                    //如果返回所有的聊天记录，数据量太大
                    //测试只返回最近的一天的数据
                    //在这里进行日期的转换吧vals.length
                    socket.emit('show historyMsgSearchByContent', vals);
                }
            }
        });
    });


    //获取上级的列表
    socket.on('get leaders', function () {
        logger.info("提交用户的userID--chat_user表："+socket.userid);
        //根据当前用户查询上级
        //这里查询的是所有的用户？？？？？？？？？？？？？？？？？？？？？？？？？？
        //内部人员 userType为0
        var sql = "select * from chat_user where userType=0;";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    return;
                } else {
                    //循环该列表，获取所有在线用户
                    var show_leaders={};
                    for (var i = 0; i < vals.length; i++) {
                        var id = vals[i].id;
                        //var name = vals[i].chatUserName;
                        show_leaders[id] = vals[i];
                    }
                    //回调该用户客户端
                    socket.emit('show leaders', show_leaders);
                }
            }
        });

    });

    //按查询条件获取上级的列表
    socket.on('search leaders', function (word) {
        //根据当前用户查询上级
        //这里查询的是所有的用户？？？？？？？？？？？？？？？？？？？？？？？？？？
        //内部人员 userType为0
        var show_leaders={};
        var sql = "select * from chat_user where userType=0 and showName like '%"+word+"%';";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    socket.emit('show leaders', show_leaders);
                } else {
                    //循环该列表，获取所有在线用户
                    for (var i = 0; i < vals.length; i++) {
                        var id = vals[i].id;
                        //var name = vals[i].chatUserName;
                        show_leaders[id] = vals[i];
                    }
                    //回调该用户客户端
                    socket.emit('show leaders', show_leaders);
                }
            }
        });

    });

    //提交人员变更消息
    socket.on('save userChangeInfo', function (leaderIds,explainInfo,roomid) {
        logger.info("提交用户的userID--chat_user表："+socket.userid);
        //没有就插入一条数据
        //提交前需要进行下判断，判断该用户时候已经被退出了该群
        var sql = "select * from chat_room_member where userId="+socket.userid+" and roomId="+roomid+";";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    socket.emit('show message', "你已经退出了该群，无法再进行变更，请重新登陆查看！");
                } else {
                    //查出房间名称
                    var roomName="";
                    var sql1 = "select * from chat_room where id="+roomid+";";
                    db_select(sql1, function (err, vals, fields) {
                        if (err) {
                            logger.info(err);
                        } else {
                            roomName=vals[0].roomName;
                            //还需判断是否重复提交 未处理的  已经处理就不再该群里了
                            //让他可以重复提交吧，后台进行变更的时候判断
                            var insertSql = "insert into chat_person_change (`roomId` ,`roomName` ,`applyPersonId`,`applyPersonName` ,`applyTime`,`changeExplain`,`handerId`,`state`) VALUES " +
                                "('" + roomid + "','"+roomName+"'," + socket.userid + ",'"+socket.nickname+"', now(),'"+explainInfo+"','"+leaderIds+"',0)";
                            logger.info("人员变更sql："+insertSql);
                            db_insert(insertSql, function (err, vals, fields) {
                                if (err) {
                                    throw err;
                                } else {
                                    logger.info("提交人员变更消息到数据库成功！");
                                    socket.emit('save userChangeInfo success');
                                }
                            });
                        }
                    });

                }
            }
        });
    });


    //添加群时获取群成员
    socket.on('get roomUsers1', function (type) {
        //查询的时候需要排除掉自己
        logger.info("提交用户的userID--chat_user表："+socket.userid);
        //内部人员 userType为0
        var sql = "select * from chat_user where userType="+type+";";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    return;
                } else {
                    //循环该列表，获取所有在线用户
                    var show_roomUsers={};
                    for (var i = 0; i < vals.length; i++) {
                        var id = vals[i].id;
                        if(id!=socket.userid){
                            show_roomUsers[id] = vals[i];
                        }
                    }
                    //回调该用户客户端
                    socket.emit('show roomUsers', show_roomUsers);
                }
            }
        });
    });

    //添加群时，查询内部或外部的人员
    socket.on('search addRoom users', function (word,type) {
        //内部人员 userType为0
        //循环该列表，获取所有在线用户
        var show_roomUsers={};
        var sql = "select * from chat_user where userType="+type+" and showName like '%"+word+"%';";
        logger.info("添加群时，查询内部或外部的人员sql："+sql);
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    socket.emit('show roomUsers', show_roomUsers);
                } else {
                    for (var i = 0; i < vals.length; i++) {
                        var id = vals[i].id;
                        show_roomUsers[id] = vals[i];
                    }
                    //回调该用户客户端
                    socket.emit('show roomUsers', show_roomUsers);
                }
            }
        });
    });
    //创建一个群
    socket.on('save persion', function (roomid,jrgwId) {
        var selectsql = "select * from chat_room_member where roomid=" + roomid;
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    socket.emit('show message', "聊天室成员为0");
                } else if (vals.length == 1) {
                    var insertSql = "insert into chat_room_member (`userId` ,`createtime`,`roomId`)" +
                        " VALUES (" + jrgwId + ",now()," + roomid + ")";
                    logger.info("插入金融顾问sql：" + insertSql);
                    db_insert(insertSql, function (err, vals, fields) {
                        if (err) {
                            throw err;
                        } else {
                            socket.emit('show message', "插入成功");
                        }
                    });
                } else {
                    socket.emit('show message', "聊天室已经存在接待员");
                }
            }
        });
    })
    //创建一个群
    socket.on('creat room', function (ids,names,roomName) {
        //logger.info("用户名ssss："+names);
        //state 0, '活跃'  1, '关闭'
        var id_arr=ids.split(",");
        var name_arr=names.split(",");

        var num=id_arr.length;
        logger.info("提交用户的userID--chat_user表："+socket.userid);
        //先创建一个房间
        //roomNum 聊天室号码 当前时间+三位随机数
        var nowDate = moment().format('YYYYMMDDHHmmss');
        var roomNum=nowDate+getRandomStr(3);
        logger.info("生成的聊天室号码为："+roomNum);

        //roomName 聊天室房间名生成规则：群名称默认为客户姓名+手机号前三位和后四位
        //先判断群成员有没有客户有几个客户
        var customerNum=getCustomerNum(ids);


        if(customerNum==0){
            socket.emit('show message', "请添加一个客户！");
        }else if(customerNum>1){
            socket.emit('show message', "只能添加一个客户！");
        }else{
            roomName=getRoomName(ids);
            //先判断一下聊天室的名称是否重复
            var sql = "select * from chat_room where roomName = '"+roomName+"';";
            db_select(sql, function (err, vals, fields) {
                if (err) {
                    logger.error(err);
                } else {
                    if (vals.length == 0) {
                        //没有重复的名字，此时插入数据
                        var insertSql = "insert into chat_room (`roomName` ,`createtime`,`createPersonId`,`createPersonName`,`state`,`roomType`,`imgPath`,`roomNum`,`roomMaxNum`)" +
                            " VALUES ('" + roomName + "',now(),'" + socket.userid + "', '"+socket.nickname+"',0,0,'"+"图像路径"+"','"+roomNum+"',"+num+")";
                        //logger.info("插入聊天内容sql："+insertSql);
                        db_insert(insertSql, function (err, vals, fields) {
                            if (err) {
                                throw err;
                            } else {
                                logger.info("创建聊天室房间成功！:"+vals.insertId);
                                var roomId=vals.insertId;
                                //房间中加入用户
                                for(var i=0;i<id_arr.length;i++){
                                    //logger.info("id："+id_arr[i]);
                                    var userId=id_arr[i];
                                    //没有就插入一条数据
                                    var insertSql = "insert into chat_room_member (`roomId` ,`userId`,`createtime`) VALUES (" + roomId + "," + userId + ", now())";
                                    //logger.info("插入聊天内容sql："+insertSql);
                                    db_insert(insertSql, function (err, vals, fields) {
                                        if (err) {
                                            throw err;
                                        } else {
                                            //logger.info("插入聊天室成员到数据库成功！");
                                            if (name_arr[i] in users2) {
                                                //主动加上新创建的聊天室
                                                users2[name_arr[i]].emit('show newRoom',name_arr[i]);
                                            }
                                        }
                                    });
                                }

                                //把自己也加进去
                                var insertSql2 = "insert into chat_room_member (`roomId` ,`userId`,`createtime`) VALUES (" + roomId + "," + socket.userid + ", now())";
                                //logger.info("插入聊天内容sql："+insertSql);
                                db_insert(insertSql2, function (err, vals, fields) {
                                    if (err) {
                                        throw err;
                                    } else {
                                        //logger.info("插入聊天室成员到数据库成功！");
                                        users2[socket.nickname].emit('show newRoom',socket.nickname);
                                    }
                                });

                                //这几个成员需要刷新
                                /*for(var i=0;i<name_arr.length;i++){
                                 if (name_arr[i] in users2) {
                                 //主动加上新创建的聊天室
                                 users2[name_arr[i]].emit('show newRoom',name_arr[i]);
                                 }
                                 }*/
                                //关闭弹出的layer
                                socket.emit('createRoom success');
                            }
                        });
                    } else {
                        //名字已经有了
                        socket.emit('show message', "该客户已经加入了聊天室！");
                    }
                }
            });
        }
    });
    //加载客户档案信息
    socket.on('get customerInfo', function (roomId) {
        //console.log("获取客户信息");
        //根据roomId获取群里的唯一的一个客户
        var sql = "select * from chat_user where id in (select userId from chat_room_member where roomId="+roomId+") and userType = 1;";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    //该群里没有客户
                    socket.emit('show customerInfo', "");
                } else {
                    //取出第一个
                    //说明有客户
                    var chatUser=vals[0];
                    //查询cs_person表获取客户姓名，手机号，地址信息
                    var pserdonsql = "select * from cs_person where id = "+chatUser.systemUserId+";";
                    db_select(pserdonsql, function (err, vals, fields) {
                        if (err) {
                            logger.error(err);
                        } else {
                            if (vals.length == 0) {
                                //查询cs_person表数据错误
                                socket.emit('show customerInfo', "");
                            } else {
                                //取出第一个 //说明有客户
                                //查询cs_person表获取客户姓名，手机号，地址信息
                                console.log("获取客户信息");
                                var person=vals[0];
                                socket.emit('show customerInfo', person);
                                //查询BpCustProspectiveFollowup表
                                var followupInfosql = "select * from bp_cust_prospective_followup where cid = "+person.id+" order by followId desc;";
                                db_select(followupInfosql, function (err, vals, fields) {
                                    if (err) {
                                        logger.error(err);
                                    } else {
                                        if (vals.length == 0) {
                                            //没有跟进信息
                                            socket.emit('show followupInfo', "");
                                        } else {
                                            var followup=vals[0];//最近一条的跟进信息,可以展示上次的沟通结果和备注信息
                                            console.log("获取跟进信息成功");
                                            socket.emit('show followupInfo', followup);
                                        }
                                    }
                                })

                                //查询SlSmallloanProject表，意向信息表，也是查最近的一条吧
                                var projectInfosql = "select * from sl_smallloan_project where oppositeID = "+person.id+" order by projectId desc;";
                                db_select(projectInfosql, function (err, vals, fields) {
                                    if (err) {
                                        logger.error(err);
                                    } else {
                                        if (vals.length == 0) {
                                            //没有跟进信息
                                            socket.emit('show projectInfo', "");
                                        } else {
                                            var projectInfo=vals[0];//最近一条的意向信息,可以展示融资金额和融资期限
                                            console.log("获取意向信息成功");
                                            socket.emit('show projectInfo', projectInfo);
                                        }
                                    }
                                })

                            }
                        }
                    });
                }
            }
        });
    });


    //保存聊天的跟进信息
    socket.on('saveCustomerInfo', function (followupInfoId,followResult,remark) {
        //查询BpCustProspectiveFollowup表
        var updateSql = "update bp_cust_prospective_followup set followInfo='" + followResult + "',remark='"+remark+"'  where followId = "+followupInfoId+" ;";
        db_update(updateSql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    //没有跟进信息
                    socket.emit('show message', "未找到对应的跟进信息，请重试！");
                } else {
                    socket.emit('show message', "保存成功！");
                }
            }
        })
    });


    //加载群成员
    socket.on('get roomUsers', function (roomId) {
        var show_roomUsers={};
        var sql = "select * from chat_user where id in(select userId from chat_room_member where roomId="+roomId+");";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    socket.emit('initRoomUsers', show_roomUsers);
                } else {
                    for (var i = 0; i < vals.length; i++) {
                        var id = vals[i].id;
                        show_roomUsers[id] = vals[i];
                    }
                    //回调该用户客户端
                    socket.emit('initRoomUsers', show_roomUsers,roomId);
                }
            }
        });
    });


    //生成聊天室邀请码
    socket.on('get roomShareCode', function (roomId) {
        //生成邀请码
        var userId=socket.userid;
        var shareCode=getRandomStr(16);
        //存入数据库
        var insertSql = "insert into chat_share_code (`roomId` ,`createuserid` ,`sharecode` ,`createTime`,`state`) VALUES ('" + roomId + "',"+userId+",'"+shareCode+"', now(),0)";
        db_insert(insertSql, function (err, vals, fields) {
            if (err) {
                throw err;
            } else {
                logger.info("生成聊天室邀请码成功！");
                //返回邀请码
                //组装链接
                var serverUrl=config.shareodecserverURL;
                socket.emit('show roomShareCode', serverUrl+"?roomId="+roomId+"&shareCode="+shareCode);
            }
        });
    });





    //创建一个群
    socket.on('mobilecreat room', function (ids,names,roomName) {
        //logger.info("用户名ssss："+names);
        //state 0, '活跃'  1, '关闭'
        var id_arr=ids.split(",");
        var name_arr=names.split(",");

        var num=id_arr.length;
        logger.info("提交用户的userID--chat_user表："+socket.userid);
        //先创建一个房间
        //roomNum 聊天室号码 当前时间+三位随机数
        var nowDate = moment().format('YYYYMMDDHHmmss');
        var roomNum=nowDate+getRandomStr(3);
        logger.info("生成的聊天室号码为："+roomNum);

        //先判断一下聊天室的名称是否重复

        //先判断一下聊天室的名称是否重复
        var sql = "select * from chat_room where roomName = '"+roomName+"';";
        db_select(sql, function (err, vals, fields) {
            if (err) {
                logger.error(err);
            } else {
                if (vals.length == 0) {
                    //没有重复的名字，此时插入数据
                    var insertSql = "insert into chat_room (`roomName` ,`createtime`,`createPersonId`,`createPersonName`,`state`,`roomType`,`imgPath`,`roomNum`,`roomMaxNum`)" +
                        " VALUES ('" + roomName + "',now(),'" + socket.userid + "', '"+socket.nickname+"',0,0,'"+"图像路径"+"','"+roomNum+"',"+num+")";
                    //logger.info("插入聊天内容sql："+insertSql);
                    db_insert(insertSql, function (err, vals, fields) {
                        if (err) {
                            throw err;
                        } else {
                            logger.info("创建聊天室房间成功！:"+vals.insertId);
                            var roomId=vals.insertId;
                            //房间中加入用户
                            for(var i=0;i<id_arr.length;i++){
                                //logger.info("id："+id_arr[i]);
                                var userId=id_arr[i];
                                //没有就插入一条数据
                                var insertSql = "insert into chat_room_member (`roomId` ,`userId`,`createtime`) VALUES (" + roomId + "," + userId + ", now())";
                                //logger.info("插入聊天内容sql："+insertSql);
                                db_insert(insertSql, function (err, vals, fields) {
                                    if (err) {
                                        throw err;
                                    } else {
                                        //logger.info("插入聊天室成员到数据库成功！");
                                        if (name_arr[i] in users2) {
                                            //主动加上新创建的聊天室
                                            users2[name_arr[i]].emit('show newRoom',name_arr[i]);
                                        }
                                    }
                                });
                            }

                            //把自己也加进去
                            var insertSql2 = "insert into chat_room_member (`roomId` ,`userId`,`createtime`) VALUES (" + roomId + "," + socket.userid + ", now())";
                            //logger.info("插入聊天内容sql："+insertSql);
                            db_insert(insertSql2, function (err, vals, fields) {
                                if (err) {
                                    throw err;
                                } else {
                                    //logger.info("插入聊天室成员到数据库成功！");
                                    users2[socket.nickname].emit('show newRoom',socket.nickname);
                                }
                            });

                            //这几个成员需要刷新
                            /*for(var i=0;i<name_arr.length;i++){
                             if (name_arr[i] in users2) {
                             //主动加上新创建的聊天室
                             users2[name_arr[i]].emit('show newRoom',name_arr[i]);
                             }
                             }*/
                            //关闭弹出的layer
                            socket.emit('createRoom success',vals);
                        }
                    });
                } else {
                    //名字已经有了
                    socket.emit('show message', "该聊天室名称已经存在，请重新取名！");
                    socket.emit('loginroom',vals);
                }
            }
        });
    });

});

/*https.createServer(function(req,res){

}).listen(config.serverPort,function (){
    console.log('监听 *:3000');
    logger.info('监听 *:3000');
});*/

http.listen(config.serverPort, function () {
    console.log('监听 *:3000');
    logger.info('监听 *:3000');
});

//=================================================上面为nodejs服务部分===================================================

//=================================================下面为function方法部分===================================================

//测试
function test(str) {
    logger.info('测试：' + str);
}

//判断存放今天的文件夹是否存在，不存在就创建
function todayFileDirIsExist(dirPath) {
    //判断一下当前日期的文件夹是否存在
    //当该文件夹不存在时候，创建
    if (!fs.existsSync(dirPath)) {
        fs.mkdirSync(dirPath);
        logger.info('文件目录已创建成功');
    }
}
//按条保存聊天记录的明细
function saveContentDetail(roomid,userId,userName,content) {
    var insertSql = "insert into chat_log_detail (`roomId` ,`userId` ,`userShowName` ,`content`,`chatTime`) VALUES ('" + roomid + "',"+userId+",'"+userName+"','" + content+ "', now())";
    db_insert(insertSql, function (err, vals, fields) {
        if (err) {
            throw err;
        } else {
            logger.info("插入聊天内容明细到数据库成功！");
        }
    });
}
//保存聊天记录的方法
function saveContent(roomid, befContent,content,aftContent) {
    //logger.info("保存聊天记录的roomID为："+roomid);
    var words=[befContent,content,aftContent];
    //先判断当日的该聊天室的是否有数据
    // 没有，新建一条，数据写进去
    // 有，更新
    var contentSql = "select * from chat_log where roomId='" + roomid + "' and to_days(chatTime) = to_days(now());";
    //logger.info("contentSql:"+contentSql);
    db_select(contentSql, function (err, vals, fields) {
        if (err) {
            logger.error(err);
        } else {
            if (vals.length == 0) {
                //没有就插入一条数据
                        var insertSql = "insert into chat_log (`roomId` ,`chatLog`,`chatTime`) VALUES ('" + roomid + "','" + words[0] + "', now())";
                        //logger.info("插入聊天内容sql："+insertSql);
                        db_insert(insertSql, function (err, vals, fields) {
                            if (err) {
                                throw err;
                            } else {
                                var updateSql4 = "update chat_log set chatLog=CONCAT(chatLog,'" + words[1] + "') where roomId='"+roomid+"' and to_days(chatTime) = to_days(now())";
                                //logger.info("updateSql:"+updateSql);
                                db_update(updateSql4, function (err, vals, fields) {
                                    if (err) {
                                        throw err;
                                    } else {
                                        var updateSql5 = "update chat_log set chatLog=CONCAT(chatLog,'" + words[2] + "') where roomId='"+roomid+"' and to_days(chatTime) = to_days(now())";
                                        //logger.info("updateSql:"+updateSql);
                                        db_update(updateSql5, function (err, vals, fields) {
                                            if (err) {
                                                throw err;
                                            } else {
                                                logger.info("插入聊天内容到数据库成功！");
                                            }
                                        });
                                    }
                                });
                            }
                        });

            } else {
                //查询到了，在chatLog字段后添加
                //mysql向表中某字段后追加一段字符串:
                //循环可能出现顺序问题
                //for(var i=0;i<3;i++){
                    var updateSql1 = "update chat_log set chatLog=CONCAT(chatLog,'" + words[0] + "') where roomId='"+roomid+"' and to_days(chatTime) = to_days(now())";
                    console.log("updateSql1:"+updateSql1);
                    db_update(updateSql1, function (err, vals, fields) {
                        if (err) {
                            throw err;
                        } else {
                            var updateSql2 = "update chat_log set chatLog=CONCAT(chatLog,'" + words[1] + "') where roomId='"+roomid+"' and to_days(chatTime) = to_days(now())";
                            //logger.info("updateSql:"+updateSql);
                            db_update(updateSql2, function (err, vals, fields) {
                                if (err) {
                                    throw err;
                                } else {
                                    var updateSql3 = "update chat_log set chatLog=CONCAT(chatLog,'" + words[2] + "') where roomId='"+roomid+"' and to_days(chatTime) = to_days(now())";
                                    //logger.info("updateSql:"+updateSql);
                                    db_update(updateSql3, function (err, vals, fields) {
                                        if (err) {
                                            throw err;
                                        } else {
                                            logger.info("插入聊天内容到数据库成功！");
                                        }
                                    });
                                }
                            });
                        }
                    });
                }
            //}
        }
    });


}

//根据成员id的数据获取客户的个数
function getCustomerNum(ids){
    var len=0;
    var selectSql = "select * from chat_user c,cs_person p where c.systemUserId=p.id and c.userType=1 and c.id in ("+ids+") ";
    db_select(selectSql, function (err, vals, fields) {
        if (err) {
            throw err;
        } else {
            len=vals.length;
        }
    })
    return len;
}

//根据成员id的数据生成群名称
function getRoomName(ids){
    var roomName="";
    var selectSql = "select * from chat_user c,cs_person p where c.systemUserId=p.id and c.userType=1 and c.id in ("+ids+") ";
    db_select(selectSql, function (err, vals, fields) {
        if (err) {
            throw err;
        } else {
            var personName=vals[0].name;
            var phone=vals[0].telphone;
            var beforeStr = phone.substring(0, 3);
            var afterStr = phone.substring(7, 11);
            roomName=personName+beforeStr+afterStr;
        }
    })
    return roomName;
}
//替换所有的回车换行
function trim2(content) {
    var string = content;
    try {
        string = string.replace(/\r\n/g, "<br />")
        string = string.replace(/\n/g, "<br />");
    } catch (e) {
        logger.error(e.message);
    }
    return string;
}

//根据文件名（非图片）获取文件的类型，并把文件图标赋值
function getFileIconName(filename) {
    var fileIconName = filename;
    var res = fileIconName.indexOf("\.");
    if (res > 0) {//文件包含点，此处认为是有文件类型的，进行文件名的重组
        var n = fileIconName.lastIndexOf("\.");
        var fileType = fileIconName.substring(n + 1, fileIconName.length).toLowerCase();//转小写
        //.toLowerCase() == str.toLowerCase()
        logger.info("截取的文件类型为：" + fileType);
        if (fileType === "zip" || fileType === "rar" || fileType === "7z" || fileType === "cab" || fileType === "iso") {
            fileIconName = "compress.jpg";//压缩文件
        } else if (fileType === "xls" || fileType === "xlsx" || fileType === "xlsb" || fileType === "xlsm" || fileType === "xlst") {
            fileIconName = "Excel.jpg";//Excel文件
        } else if (fileType === "docx" || fileType === "doc") {
            fileIconName = "word.jpg";//word文件
        } else if (fileType === "pdf") {
            fileIconName = "pdf.jpg";//pdf文件
        } else if (fileType === "ppt") {
            fileIconName = "ppt.jpg";//ppt文件
        } else if (fileType === "text") {
            fileIconName = "file.jpg";//text文件
        } else if (fileType === "text") {
            fileIconName = "file.jpg";//text文件
        } else {
            fileIconName = "nofile.jpg";//没有文件类型的文件
        }
        <!--音乐文件 music.jpg-->
        <!--视频文件 video.jpg-->
        <!--应用程序 program.jpg-->

    } else {
        fileIconName = "nofile.jpg";//没有文件类型的文件
    }
    return fileIconName;
}
//文件同名时，更改文件名  (暂未写好)
//规则为 在文件名字后加上：（1）
//括号内数字递增
function getDifName(filePath) {
    fs.exists(filePath, function (exists) {
        if (exists) {

        }
    });
}

/*
 四舍五入保留小数位数
 numberRound 被处理的数
 roundDigit  保留几位小数位
 */
function roundFun(numberRound, roundDigit)   //处理金额 -by hailang
{
    if (numberRound >= 0) {
        var tempNumber = parseInt((numberRound * Math.pow(10, roundDigit) + 0.5)) / Math.pow(10, roundDigit);
        return tempNumber;
    } else {
        numberRound1 = -numberRound
        var tempNumber = parseInt((numberRound1 * Math.pow(10, roundDigit) + 0.5)) / Math.pow(10, roundDigit);
        return -tempNumber;
    }
}

/*附件大小格式处理*/
function renderSize(value) {
    if (null == value || value == '') {
        return "0 Bytes";
    }
    var unitArr = new Array("Bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB");
    var index = 0;
    var srcsize = parseFloat(value);
    var size = roundFun(srcsize / Math.pow(1024, (index = Math.floor(Math.log(srcsize) / Math.log(1024)))), 2);
    return size + unitArr[index];
}

/*获取随机数  len为位数*/
function getRandomStr(len){
    var rand = "";
    for(var i = 0; i < len; i++){
        var r = Math.floor(Math.random() * 10);
        rand += r;
    }
    return rand;
}
//主要是英文单引号，其他还没有发现问题
//反斜杠也不行  \
function formatSpecialWord(string){
    if (string.length>0)
    {
        string = string.replace("\\","/");
        string = string.replace("\\\\","//");
        string = string.replace("'","’");
        //string = string.replace("%","\%");
        //string = string.replace("&","\&");
        //string = string.replace(";","\;");
    }
    return string;
}
//计算
function  compute(params){
    switch(params['type']){
        case "add": return parseFloat(params['num']) + parseFloat(params['num1']);break;
        case "subtract": return parseFloat(params['num']) - parseFloat(params['num1']);break;
        case "multiplication": return parseFloat(params['num']) * parseFloat(params['num1']);break;
        case "division": return parseFloat(params['num']) / parseFloat(params['num1']);break;
    }
}
function getNowFormatDate() {
    var date = new Date();
    var seperator1 = "-";
    var seperator2 = ":";
    var month = date.getMonth() + 1;
    var strDate = date.getDate();
    if (month >= 1 && month <= 9) {
        month = "0" + month;
    }
    if (strDate >= 0 && strDate <= 9) {
        strDate = "0" + strDate;
    }
    var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate
        + " " + date.getHours() + seperator2 + formatTime(date.getMinutes())
        + seperator2 + formatTime(date.getSeconds());
    return currentdate;
}
//格式化时间：分秒。
function formatTime (i){
    if(i < 10){
        i = "0" + i;
    }
    return i;
}